;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane10-12#w dane10-16#w dane12-16#w dane12-20#w dane16-20#w dane16-25#w 
		    dane20-25#w dane20-31#w dane25-31#w dane25-40#w dane31-40#w dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  ("d1mm" "150") ("d3mm" "400") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))

;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;10-12
((and (not dane10-12#w)(= i#w "10-12"))
     (progn (load (strcat sciezkaPlik#w plik#w "_10-12.lsp"))
            (setq dane10-12#w (obliczPa1#w)) ))
;10-16
((and (not dane10-16#w)(= i#w "10-16"))
     (progn (load (strcat sciezkaPlik#w plik#w "_10-16.lsp"))
            (setq dane10-16#w (obliczPa1#w)) ))
;12-16
((and (not dane12-16#w)(= i#w "12-16"))
     (progn (load (strcat sciezkaPlik#w plik#w "_12-16.lsp"))
            (setq dane12-16#w (obliczPa1#w)) ))
;12-20
((and (not dane12-20#w)(= i#w "12-20"))
     (progn (load (strcat sciezkaPlik#w plik#w "_12-20.lsp"))
            (setq dane12-20#w (obliczPa1#w)) ))
;16-20
((and (not dane16-20#w)(= i#w "16-20"))
     (progn (load (strcat sciezkaPlik#w plik#w "_16-20.lsp"))
            (setq dane16-20#w (obliczPa1#w)) ))
;16-25
((and (not dane16-25#w)(= i#w "16-25"))
     (progn (load (strcat sciezkaPlik#w plik#w "_16-25.lsp"))
            (setq dane16-25#w (obliczPa1#w)) ))

;20-25
((and (not dane20-25#w)(= i#w "20-25"))
     (progn (load (strcat sciezkaPlik#w plik#w "_20-25.lsp"))
            (setq dane20-25#w (obliczPa1#w)) ))
;20-31
((and (not dane20-31#w)(= i#w "20-31"))
     (progn (load (strcat sciezkaPlik#w plik#w "_20-31.lsp"))
            (setq dane20-31#w (obliczPa1#w)) ))
;25-31
((and (not dane25-31#w)(= i#w "25-31"))
     (progn (load (strcat sciezkaPlik#w plik#w "_25-31.lsp"))
            (setq dane25-31#w (obliczPa1#w)) ))
;25-40
((and (not dane25-40#w)(= i#w "25-40"))
     (progn (load (strcat sciezkaPlik#w plik#w "_25-40.lsp"))
            (setq dane25-40#w (obliczPa1#w)) ))
;31-40
((and (not dane31-40#w)(= i#w "31-40"))
     (progn (load (strcat sciezkaPlik#w plik#w "_31-40.lsp"))
            (setq dane31-40#w (obliczPa1#w)) ))

));cond/foreach


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
              parametr#w  (cadar rozmiar#w)
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
	(cond

	;10-12
	((= parametr#w "10-12") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane10-12#w ) 
                             )))))
	;10-16
	((= parametr#w "10-16") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane10-16#w ) 
                             )))))
	;12-16
	((= parametr#w "12-16") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane12-16#w ) 
                             )))))
	;12-20
	((= parametr#w "12-20") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane12-20#w ) 
                             )))))
	;16-20
	((= parametr#w "16-20") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane16-20#w ) 
                             )))))
	;16-25
	((= parametr#w "16-25") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane16-25#w ) 
                             )))))

	;20-25
	((= parametr#w "20-25") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane20-25#w ) 
                             )))))
	;20-31
	((= parametr#w "20-31") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane20-31#w ) 
                             )))))
	;25-31
	((= parametr#w "25-31") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane25-31#w ) 
                             )))))
	;25-40
	((= parametr#w "25-40") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane25-40#w ) 
                             )))))
	;31-40
	((= parametr#w "31-40") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane31-40#w ) 
                             )))))
	;inne - nieliczone rozmiary
	( T                  (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
					akcesoria#w nil ) 
                             )))))
	);cond

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w parametr#w akcesoria#w dane#w /
		   nastawa#w nastawa1#w p#w d#w f#w text#w wyd#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("Wielko" "10-12") ("d2mm" "100") ("d1mm" "125") ("Lmm" "320") ("Bmm" "320") ("Hmm" "170") ("Amm" "210"))
;kierunki#w (("P1" "d1mm" "600.00" (-348.838 176.616 0.0) "P2" "d1mm" "600.00" (-348.838 179.356 0.0)))
;dane#w (("0" "10" "50")...)
;parametr#w "10-12"
;akcesoria#w (("WentyleFlaktbRH1_Nastawy" "1") ("WentyleFlaktbRH1_Kp" "1") ("WentyleFlaktbRH1_Tp" "1"))


(if (not dane#w)
    (setq zwrot#w (list "" (strcat "0;Brak danych o spadkach cinie dla rozmiaru " parametr#w) ))

;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

(setq nastawa#w (cadar akcesoria#w))	

		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "otw.100%"))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "otw.80%"))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "otw.60%"))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "otw.40%"))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "otw.20%"))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "otw.0%"))
		);cond

(setq kierTu#w (car kierunki#w))

               ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w)
		(setq d#w  (/ (atof (cadr (assoc d#w rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4))  ;[m2]
		(setq text#w (strcat "0;Nawiewnik," nastawa1#w))

(setq wyd#w (atof (nth 2 kierTu#w)) ) ;[m3/h]
(setq wyd#w (/ wyd#w 3.6)) ;[l/s]

;wywoanie odczytu dPa z tablicy/wykresu
;(Nastawa, Wyd[l/s], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w (itoa (- 100 (* (atoi nastawa#w) 20))) (rtos wyd#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

));progn-else/if parametr#w

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 






