;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane400#w dane100#w dane125#w dane160#w dane200#w dane250#w 
		    dane315#w dane400#w dane500#w dane630#w dane#w ) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w      
;  rozmiar#w  ("d1mm" "150") ("d3mm" "400") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))  


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))

;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;80
((and (not dane80#w)(= i#w "80"))
     (progn (load (strcat sciezkaPlik#w plik#w "_80.lsp"))
            (setq dane80#w (obliczPa1#w)) ))
;100
((and (not dane100#w)(= i#w "100"))
     (progn (load (strcat sciezkaPlik#w plik#w "_100.lsp"))
            (setq dane100#w (obliczPa1#w)) ))
;125
((and (not dane125#w)(= i#w "125"))
     (progn (load (strcat sciezkaPlik#w plik#w "_125.lsp"))
            (setq dane125#w (obliczPa1#w)) ))
;160
((and (not dane160#w)(= i#w "160"))
     (progn (load (strcat sciezkaPlik#w plik#w "_160.lsp"))
            (setq dane160#w (obliczPa1#w)) ))
;200
((and (not dane200#w)(= i#w "200"))
     (progn (load (strcat sciezkaPlik#w plik#w "_200.lsp"))
            (setq dane200#w (obliczPa1#w)) ))
;250
((and (not dane250#w)(= i#w "250"))
     (progn (load (strcat sciezkaPlik#w plik#w "_250.lsp"))
            (setq dane250#w (obliczPa1#w)) ))
;315
((and (not dane315#w)(= i#w "315"))
     (progn (load (strcat sciezkaPlik#w plik#w "_315.lsp"))
            (setq dane315#w (obliczPa1#w)) ))
;400
((and (not dane400#w)(= i#w "400"))
     (progn (load (strcat sciezkaPlik#w plik#w "_400.lsp"))
            (setq dane400#w (obliczPa1#w)) ))
;500
((and (not dane500#w)(= i#w "500"))
     (progn (load (strcat sciezkaPlik#w plik#w "_500.lsp"))
            (setq dane500#w (obliczPa1#w)) ))
;630
((and (not dane630#w)(= i#w "630"))
     (progn (load (strcat sciezkaPlik#w plik#w "_630.lsp"))
            (setq dane630#w (obliczPa1#w)) ))

));cond/foreach


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
              parametr#w  (cadar rozmiar#w)
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

	(setq zwrotObi#w '())
	(cond

	;80
	((= parametr#w "80") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane80#w ) 
                             )))))
	;100
	((= parametr#w "100") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane100#w ) 
                             )))))
	;125
	((= parametr#w "125") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane125#w ) 
                             )))))
	;160
	((= parametr#w "160") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane160#w ) 
                             )))))
	;200
	((= parametr#w "200") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane200#w ) 
                             )))))
	;250
	((= parametr#w "250") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane250#w ) 
                             )))))
	;315
	((= parametr#w "315") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane315#w ) 
                             )))))
	;400
	((= parametr#w "400") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane400#w ) 
                             )))))
	;500
	((= parametr#w "500") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane500#w ) 
                             )))))
	;630
	((= parametr#w "630") (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane630#w ) 
                             )))))

	;inne - nieliczone rozmiary
	( T                  (setq  zwrotObi#w (append zwrotObi#w (list (append (list kiery#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
					akcesoria#w nil ) 
                             )))))
	);cond

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w parametr#w akcesoria#w dane#w /
		   nastawa#w p#w d#w f#w text#w wyd#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("d1mm" "100") ("d3mm" "100") ("Lmm" "151") ("Hmm" "65") ("kgTCPL" "0.5"))
;kierunki#w (("P3" "d3mm" "100.00" (120.517 23.9185 0.0) "P1" "d1mm" "200.00" (112.967 
;            30.4185 0.0)) ("P2" "d1mm" "100.00" (128.067 30.4185 0.0) "P1" "d1mm" "200.00" 
;            (112.967 30.4185 0.0)))
;dane#w (("1" "2.2" "1.1") ("1" "2.3" "1.2")...)
;parametr#w "80" 
;akcesoria#w (("WentyleSpiroRGS_akcesoria" "1") ("WentyleSpiroRGS_lamelki" "1") 
;             ("WentyleSpiroRGS_przepustnica" "0"))

(if (not dane#w)
    (setq zwrot#w (list "" (strcat "0;Brak danych o spadkach cinie dla rozmiaru " parametr#w) ))


;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

(setq nastawa#w (cadar akcesoria#w))
(cond
((= nastawa#w "0")(setq nastawa#w "30"))
((= nastawa#w "1")(setq nastawa#w "35"))
((= nastawa#w "2")(setq nastawa#w "40"))
((= nastawa#w "3")(setq nastawa#w "45"))
((= nastawa#w "4")(setq nastawa#w "50"))
((= nastawa#w "5")(setq nastawa#w "55"))
((= nastawa#w "6")(setq nastawa#w "60"))
((= nastawa#w "7")(setq nastawa#w "65"))
((= nastawa#w "8")(setq nastawa#w "70"))
((= nastawa#w "9")(setq nastawa#w "75"))
((= nastawa#w "10")(setq nastawa#w "80"))
((= nastawa#w "11")(setq nastawa#w "85"))
);cond

(setq kierTu#w (car kierunki#w))

               ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w)
		(setq d#w  (/ (atof (cadr (assoc d#w rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4))  ;[m2]
		(setq text#w (strcat "0;Przepustnica Regulacyjna,Nast." nastawa#w))

(setq wyd#w  (atof (nth 2 kierTu#w)) ) ;[m3/h]

;wywoanie odczytu dPa z tablicy/wykresu
;(Kt nastawy, Wyd[m3/h], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w  nastawa#w (rtos wyd#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

));progn-else/if parametr#w


zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 






